#version 330 core

// fragment shader

in float mynoise;

out vec4 color;

uniform sampler2D myTextureSampler;

uniform float opacity; // 12jan17 addendum

// color assigned to match radial perturbations

void main(){

   vec2 tPos = vec2( 0,  2.0 * mynoise +0.8 );

	color = texture( myTextureSampler, tPos).rgba;

	if( (opacity>0.1) && (opacity<0.99) ) color.a *= opacity;

}

/*
--
-- Copyright (C) 2017  <fastrgv@gmail.com>
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You may read the full text of the GNU General Public License
-- at <http://www.gnu.org/licenses/>.
--
*/

